Magellan Linux

Diff of /trunk/installer-simple/bin/installer.sh.in

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 2881 by niro, Thu Jul 3 08:33:54 2014 UTC revision 2882 by niro, Fri Jul 31 09:39:45 2015 UTC
# Line 99  install_meter() Line 99  install_meter()
99   return 0   return 0
100  }  }
101    
102    install_mount_rootfs()
103    {
104     local opts
105    
106     if [[ -n ${SWAPHDD} ]]
107     then
108     swapon ${SWAPHDD} || die
109     fi
110     if [[ -n ${ROOTHDD} ]]
111     then
112     mount -t ${FORMAT_FILESYSTEM_ROOTHDD} ${ROOTHDD} ${INSTALL_ROOT} || die
113     fi
114     if [[ -n ${BOOTHDD} ]]
115     then
116     install -d ${INSTALL_ROOT}/boot || die
117     mount -t ${FORMAT_FILESYSTEM_BOOTHDD} ${BOOTHDD} ${INSTALL_ROOT}/boot || die
118     fi
119    
120     cd ${INSTALL_ROOT} || die
121    }
122    
123    
124  mount_rootfs()  mount_rootfs()
125  {  {
126   local retval   local retval
127    
128   if is_mounted --location "${INSTALLROOT}"   if [[ -n ${SWAPHDD} ]]
129   then   then
130   echo $"${INSTALLROOT} already mounted" >&2   swapon ${SWAPHDD} || dialog_die $"Could not enable swap space '${SWAPHDD}'"
  else  
  mount "${ROOTHDD}" "${INSTALLROOT}" || dialog_die $"Could not mount rootfs - drive '${ROOTHDD}' -> '${INSTALLROOT}'"  
131   fi   fi
132    
133     if [[ -n ${ROOTHDD} ]]
134     then
135     if is_mounted --location "${INSTALLROOT}"
136     then
137     echo $"${INSTALLROOT} already mounted" >&2
138     else
139     mount "${ROOTHDD}" "${INSTALLROOT}" || dialog_die $"Could not mount rootfs - drive '${ROOTHDD}' -> '${INSTALLROOT}'"
140     fi
141     fi
142    
143   [[ -d ${INSTALLROOT}/boot ]] || install -d ${INSTALLROOT}/boot   [[ -d ${INSTALLROOT}/boot ]] || install -d ${INSTALLROOT}/boot
144    
145     if [[ -n ${BOOTHDD} ]]
146     then
147     if is_mounted --location "${INSTALLROOT}"/boot
148     then
149     echo $"${INSTALLROOT}/boot already mounted" >&2
150     else
151     mount "${BOOTHDD}" "${INSTALLROOT}"/boot || dialog_die $"Could not mount bootfs - drive '${BOOTHDD}' -> '${INSTALLROOT}/boot'"
152     fi
153     fi
154  }  }
155    
156  umount_rootfs()  umount_rootfs()
157  {  {
158   is_mounted --location ${INSTALLROOT}/boot && umount ${INSTALLROOT}/boot   is_mounted --location ${INSTALLROOT}/boot && umount ${INSTALLROOT}/boot
159   is_mounted --location ${INSTALLROOT} && umount ${INSTALLROOT}   is_mounted --location ${INSTALLROOT} && umount ${INSTALLROOT}
160    
161     if [[ -n ${SWAPHDD} ]]
162     then
163     swapoff ${SWAPHDD} || die
164     fi
165  }  }
166    
167  install_do_reboot()  install_do_reboot()
# Line 196  run_hardware_detection_disks() Line 242  run_hardware_detection_disks()
242   export ALL_CDROMS="$(get_hwinfo cdrom)"   export ALL_CDROMS="$(get_hwinfo cdrom)"
243  }  }
244    
245  setup_hdd_partitions_auto()  setup_hdd_partitions()
246  {  {
247   ROOTHDD="${HDD}1"   case "${INSTALL_METHOD}" in
248     auto)
249     BOOTHDD=""
250     SWAPHDD=""
251     ROOTHDD="${HDD}1"
252     ;;
253     normal)
254     BOOTHDD="${HDD}1"
255     SWAPHDD="${HDD}2"
256     ROOTHDD="${HDD}3"
257     ;;
258     esac
259    
260   # sanity check - should not happen   # sanity check - should not happen
261   if is_mounted --device "${ROOTHDD}"   if is_mounted --device "${ROOTHDD}"
# Line 206  setup_hdd_partitions_auto() Line 263  setup_hdd_partitions_auto()
263   echo "partition: device ${ROOTHDD} is already mounted, umount it" >&2   echo "partition: device ${ROOTHDD} is already mounted, umount it" >&2
264   umount "${ROOTHDD}"   umount "${ROOTHDD}"
265   fi   fi
266     if [[ -n ${BOOTHDD} ]]
  # run this only if FDISKPARTITIONBELOW256MB is not already 1  
  if [[ ${FDISKPARTIONBELOW256MB} != 1 ]]  
267   then   then
268   if device_minimum_size "${HDD}" 256   if is_mounted --device "${BOOTHDD}"
269   then   then
270   FDISKPARTIONBELOW256MB=1   echo "partition: device ${BOOTHDD} is already mounted, umount it" >&2
271   else   umount "${BOOTHDD}"
  FDISKPARTIONBELOW256MB=0  
272   fi   fi
273   fi   fi
274    
275   ## delete disk   if [[ ${INSTALL_METHOD} = auto ]]
  dd if=/dev/zero of=${HDD} count=1 &> /dev/null || dialog_die  
   
  if [[ ${FDISKPARTIONBELOW256MB} = 1 ]]  
276   then   then
277   ## setup one bootable partition   # run this only if FDISKPARTITIONBELOW256MB is not already 1
278   #1. n= new disk   if [[ ${FDISKPARTIONBELOW256MB} != 1 ]]
279   #2. p= primary disk   then
280   #3. 1= first partition   if device_minimum_size "${HDD}" 256
281   #4. 2= default sector start // small disk needs more space for grub2 mbr sector   then
282   #5. ''= defaul sector end   FDISKPARTIONBELOW256MB=1
283   #6. a= bootable flag   else
284   #7. 1= boot flag for partition 1   FDISKPARTIONBELOW256MB=0
285   #8. w= write/quit   fi
286   fdisk ${HDD} &> /dev/null << EOF   fi
287    
288     ## delete disk
289     dd if=/dev/zero of=${HDD} count=1 &> /dev/null || dialog_die
290    
291     if [[ ${FDISKPARTIONBELOW256MB} = 1 ]]
292     then
293     ## setup one bootable partition
294     #1. n= new disk
295     #2. p= primary disk
296     #3. 1= first partition
297     #4. 2= default sector start // small disk needs more space for grub2 mbr sector
298     #5. ''= defaul sector end
299     #6. a= bootable flag
300     #7. 1= boot flag for partition 1
301     #8. w= write/quit
302     fdisk ${HDD} &> /dev/null << EOF
303  n  n
304  p  p
305  1  1
# Line 242  a Line 309  a
309  1  1
310  w  w
311  EOF  EOF
312   else   else
313   ## setup one bootable partition   ## setup one bootable partition
314   #1. n= new disk   #1. n= new disk
315   #2. p= primary disk   #2. p= primary disk
316   #3. 1= first partition   #3. 1= first partition
317   #4. ''= default sector start   #4. ''= default sector start
318   #5. ''= defaul sector end   #5. ''= defaul sector end
319   #6. a= bootable flag   #6. a= bootable flag
320   #7. 1= boot flag for partition 1   #7. 1= boot flag for partition 1
321   #8. w= write/quit   #8. w= write/quit
322   fdisk ${HDD} &> /dev/null << EOF   fdisk ${HDD} &> /dev/null << EOF
323  n  n
324  p  p
325  1  1
# Line 262  a Line 329  a
329  1  1
330  w  w
331  EOF  EOF
332     fi
333     else
334     cfdisk ${HDD} || dialog_die
335   fi   fi
336  }  }
337    
 setup_hdd_partitions_manual()  
 {  
  ROOTHDD="${HDD}1"  
  SWAPHDD=""  
  BOOTHDD=""  
  cfdisk ${HDD} || dialog_die  
 }  
   
338  setup_hdd_format()  setup_hdd_format()
339  {  {
340   # sanity check - should not happen   if [[ -n ${SWAPHDD} ]]
  if is_mounted --device "${ROOTHDD}"  
341   then   then
342   echo "format: device ${ROOTHDD} is already mounted, umount it" >&2   # sanity check - should not happen
343   umount "${ROOTHDD}"   if is_mounted --device "${SWAPHDD}"
344     then
345     echo "format: device ${SWAPHDD} is already mounted, umount it" >&2
346     umount "${SWAPHDD}"
347     fi
348     mkswap ${SWAPHDD} || die
349   fi   fi
350    
351   mkfs."${FORMAT_FILESYSTEM}" -q "${ROOTHDD}" || dialog_die   if [[ -n ${BOOTHDD} ]]
352     then
353     # sanity check - should not happen
354     if is_mounted --device "${BOOTHDD}"
355     then
356     echo "format: device ${BOOTHDD} is already mounted, umount it" >&2
357     umount "${BOOTHDD}"
358     fi
359    
360     mkfs."${FORMAT_FILESYSTEM}" -q "${BOOTHDD}" || dialog_die
361     fi
362    
363     if [[ -n ${ROOTHDD} ]]
364     then
365     # sanity check - should not happen
366     if is_mounted --device "${ROOTHDD}"
367     then
368     echo "format: device ${ROOTHDD} is already mounted, umount it" >&2
369     umount "${ROOTHDD}"
370     fi
371    
372     mkfs."${FORMAT_FILESYSTEM}" -q "${ROOTHDD}" || dialog_die
373     fi
374  }  }
375    
376  install_system_image()  install_system_image()
# Line 299  install_system_settings() Line 387  install_system_settings()
387   # write fstab   # write fstab
388   CONFIG="${INSTALLROOT}/etc/fstab"   CONFIG="${INSTALLROOT}/etc/fstab"
389   clearconfig   clearconfig
390   addconfig -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1"   if [[ -n ${BOOTHDD} ]]
391     then
392     addconfig -e "UUID=$(get_uuid ${BOOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t1 1"
393     fi
394     if [[ -n ${ROOTHDD} ]]
395     then
396     addconfig -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0"
397     fi
398     if [[ -n ${SWAPHDD} ]]
399     then
400     addconfig -e "UUID='$(get_uuid ${SWAPHDD})'\tswap\tswap\tpri=1\t0 0"
401     fi
402   addconfig -e "proc\t/proc\tproc\tdefaults\t0 0"   addconfig -e "proc\t/proc\tproc\tdefaults\t0 0"
403   addconfig -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0"   addconfig -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0"
404    
# Line 360  task_setup_system_menu() Line 459  task_setup_system_menu()
459   if [[ ${retval} -eq 0 ]]   if [[ ${retval} -eq 0 ]]
460   then   then
461   case "${mode}" in   case "${mode}" in
462   "1") run_install_auto ;;   "1") run_install auto ;;
463   "2") run_install_normal ;;   "2") run_install normal ;;
464   "") task_setup_system_menu;;   "") task_setup_system_menu;;
465   esac   esac
466   fi   fi
# Line 411  task_hardware_detection() Line 510  task_hardware_detection()
510   messagebox -y 12 -h $"Detected hardware:" "${message}"   messagebox -y 12 -h $"Detected hardware:" "${message}"
511  }  }
512    
513  task_setup_hdd_partitions_manual()  task_setup_hdd_partitions()
514  {  {
515   local i   local i
516   local retval   local retval
# Line 427  task_setup_hdd_partitions_manual() Line 526  task_setup_hdd_partitions_manual()
526   if [[ ${retval} -eq 0 ]]   if [[ ${retval} -eq 0 ]]
527   then   then
528   dialog_setup_hdd_info   dialog_setup_hdd_info
529   setup_hdd_partitions_manual   setup_hdd_partitions
  fi  
  fi  
 }  
   
 task_setup_hdd_partitions_auto()  
 {  
  local i  
  local retval  
   
  if [[ -z ${ALL_DISKS} ]]  
  then  
  dialog_no_harddrive_found  
  exit 1  
  else  
  HDD=$(dialog_select_target_harddrive)  
  retval=$?  
  [[ ${retval} -eq 1 ]] && return 1  
  if [[ ${retval} -eq 0 ]]  
  then  
  dialog_setup_hdd_info_auto  
  dialog_setup_hdd_create_partitions  
  setup_hdd_partitions_auto  
530   fi   fi
531   fi   fi
532  }  }
# Line 476  task_main() Line 553  task_main()
553   done   done
554  }  }
555    
556  run_install_normal()  run_install()
557  {  {
558   task_hardware_detection   local method="$1"
   
  task_setup_hdd_partitions_manual  
  dialog_setup_hdd_format  
  setup_hdd_format > /dev/null  
  mount_rootfs  
  (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | install_meter | dialog_install_system_image  
   
  dialog_install_settings  
  sleep 1  
  install_system_settings  
  if is_initrd_supported  
  then  
  dialog_install_initrd  
  initrd_config  
  initrd_install  
  fi  
559    
  dialog_install_bootsector  
  bootloader_config  
  bootloader_install  
   
  umount_rootfs  
  dialog_install_successful  
 }  
   
 run_install_auto()  
 {  
560   task_hardware_detection   task_hardware_detection
561    
562   task_setup_hdd_partitions_auto   case "${method}" in
563     auto)
564     export INSTALL_METHOD="${method}"
565     ;;
566     normal)
567     export INSTALL_METHOD="${method}"
568     ;;
569     *)
570     die "Unknown install method '${method}', aborting."
571     ;;
572     esac
573    
574     task_setup_hdd_partitions
575   dialog_setup_hdd_format   dialog_setup_hdd_format
576   setup_hdd_format > /dev/null   setup_hdd_format > /dev/null
577   mount_rootfs   mount_rootfs

Legend:
Removed from v.2881  
changed lines
  Added in v.2882